//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "LnAlgebr.h"
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void*)
{
    return 1;
}
//---------------------------------------------------------------------------
//    
#include <iostream.h>
#include <stdlib.h>
#include <math.h>
USELIB("..\..\..\..\Program Files\Borland\CBuilder3\Lib\memmgr.lib");
//---------------------------------------------------------------------------
Vector::Vector(int r)
{
  size = r;
  v = new double[r];
  for(int i = 0; i < r; i++)
    v[i]=0.0;
}

Vector::Vector(const Vector& ob)
{
  size=ob.size;
  v=new double[size];
  for(int i = 0; i < size; i++)
   v[i] = ob.v[i];
}

ostream& operator<<(ostream& stream,const Vector& ob)
{
  for(int i=0;i<ob.size;i++) {
     stream << ob.v[i];
     stream << endl;
  }
  return stream;
}

istream& operator>>(istream& stream, Vector& ob)
{
  for(int i = 0; i < ob.size; i++){
    stream >> ob.v[i];
}
  return stream;
}

Vector& Vector::operator=(const Vector& ob)
{
  if(this != &ob){
    delete v;
    size=ob.size;
    v=new double[size];
    for(int i=0;i<ob.size;i++)
      v[i]=ob.v[i];
  }
  return *this;
}

Vector Vector::operator+(const Vector& ob)
{
  if(size!=ob.size) {
    cout << "\a Sizes of vectors must be identicals!\n";
    exit(1);
  }

  Vector sum(size);

  for(int i=0;i<size;i++) sum.v[i]=v[i]+ob.v[i];

  return sum;
}

Vector Vector::operator-(const Vector& ob)
{
  if(size!=ob.size) {
    cout << "\a Sizes of vectors sizeust be identicals!\n";
    exit(1);
  }

  Vector div(size);

  for(int i=0;i<size;i++) div.v[i]=v[i]-ob.v[i];

  return div;
}

Vector& Vector::operator*(const double d)
{
  for(int i = 0; i < size; i++)
    v[i]*=d;

  return *this;
}

Vector& Vector::operator-()
{
  for(int i=0;i<size;i++) v[i]*=(-1);

  return *this;
}

int Vector::operator==(const Vector& ob)const
{
  if(size!=ob.size) return 0;

  for(int i=0;i<size;i++)
    if(v[i]!=ob.v[i]) return 0;

  return 1;
}

int Vector::operator!=(const Vector& ob)const
{
  if(size!=ob.size) return 1;

  for(int i=0;i<size;i++)
    if(v[i]!=ob.v[i]) return 1;

  return 0;
}

double Vector::operator*(const Vector& ob)const
{
  double tmp=0.0;
  for(int i = 0; i < size; i++)
    tmp+= v[i] * ob.v[i];
  return tmp;
}

double Vector::norma()const
{
  return sqrt((*this)*(*this));
}

double V_cos(const Vector& ob1,const Vector& ob2)
{
  return(ob1*ob2/(ob1.norma()*ob2.norma()));
}

int Vector::NumbMainElement(int i)

//     ,

//      i

{
  double MainEl = fabs(v[i]);
  int NumbMain = i;
  for(int k = i + 1; k < size; k++)
    if(MainEl < fabs(v[k])){
      MainEl = fabs(v[k]);
      NumbMain = k;
    }
  return NumbMain;
}

//    
//     -

Matrix::Matrix(int n, int m)
{
      row = n; col = m;
      a = new Vector*[col];
      for(int j=0; j < col; j++)
      a[j]= new Vector(row);
}

Matrix::~Matrix()    //
{
  for(int j = 0; j < col; j++)//   
    delete a[j];        //  
  delete[] a;
}

Matrix::Matrix(const Matrix& ob)// 
{
      row = ob.row; col = ob.col;
      a = new Vector*[col];
      for(int j=0; j < col; j++){
      a[j]= new Vector(row);
      *(a[j]) = *(ob.a[j]);
    }
}

ostream& operator<<(ostream& stream, const Matrix& ob)
{
      for(int i = 0; i < ob.row; i++) {
            for(int j = 0; j < ob.col; j++)
                  stream << " " << (*ob.a[j]).v[i];
    stream << endl;
      }
      return stream;
}

istream& operator>>(istream& stream, Matrix& ob)
{
  for(int i = 0; i < ob.row; i++)
    for(int j = 0; j < ob.col; j++)
      stream >> (*ob.a[j]).v[i];
  return stream;
}

Matrix& Matrix::operator=(const Matrix& ob)
{
    if(this == &ob)
      return *this;
      if(row!=ob.row || col!=ob.col){
      for(int j = 0; j < col; j++)
        delete a[j];
      delete[] a;
    }
    row = ob.row; col = ob.col;
    a = new Vector*[col];
    for(int j = 0; j < col; j++){
      a[j]= new Vector(row);
      *(a[j]) = *(ob.a[j]);
    }
      return *this;
}

Matrix Matrix::operator+(const Matrix& ob)
{
  if(row!=ob.row && col!=ob.col) {
      cout << "\a Sizes of Matrixs must be identicals!\row";
  }
  Matrix sum(row, col);
  for(int j = 0; j < col; j++)
    *sum.a[j] = *a[j] + *ob.a[j];
  return sum;
}

Matrix Matrix::operator-(const Matrix& ob)
{
      if(row!=ob.row && col!=ob.col) {
            cout << "\a Sizes of Matrixs must be identicals!\row";
  }
      Matrix div(row, col);
      for(int j = 0; j < col; j++)
      *div.a[j] = *a[j] - *ob.a[j];
      return div;
}

Matrix& Matrix::operator*(const double d)
{
      for(int j = 0; j < col; j++)
      *a[j] = *a[j] * d;
      return *this;
}

Matrix& Matrix::operator-()
{
  for(int j = 0; j < col; j++)
    *a[j] = *a[j]*(-1);
      return *this;
}

int Matrix::operator==(const Matrix& ob)
{
      if(row!=ob.row && col!=ob.col) return 0;
      for(int j = 0; j < col; j++)
            if(*a[j] != *ob.a[j])
          return 0;
  return 1;
}

int Matrix::operator!=(const Matrix& ob)
{
  if(row!=ob.row && col!=ob.col) return 1;
      for(int j = 0; j < col; j++)
            if(a[j] != ob.a[j])
          return 1;
  return 0;
}

Vector Matrix::operator*(const Vector& vt)
{
  if(col != vt.size) {
    cout << "\nThe number of column of matrix <> the size of vector\n";
  }
  Vector mult(row);
  for(int i = 0; i < row; i++)
    for(int j = 0; j < col; j++)
      mult.v[i] += (*a[j]).v[i] * vt.v[j];
  return mult;
}

Matrix Matrix::operator*(const Matrix& b)//   
{
  if(col != b.row)
    throw ("\nThe number of column of first matrix <> "
            "the number of rows the second matrix\n");
  Matrix c(row, b.col);
  for(int i = 0; i < row; i++)
    for(int j = 0; j < b.col; j++)
      (*c.a[j]).v[i] = GetLine(i) * *b.a[j];
  return c;
}

void Matrix::SwapLines(int i, int j)
// i-  j-  
{
  double tmp;
  for(int k = 0; k < col; k++){
    tmp = (*a[k]).v[i];
    (*a[k]).v[i] = (*a[k]).v[j];
    (*a[k]).v[j] = tmp;
  }
}

void Matrix::DivLine(int i, double divisor)
// i-   divisor
{
  if(0 == divisor){
    //MessageBox(NULL, "Division the line by zero", "", MB_OK +MB_ICONEXCLAMATION);
    throw("Division the line by zero");
  }
  for(int j = 0; j < col; j++)
    (*a[j]).v[i]/= divisor;
}

void Matrix::DiffLines(int k, int i, double factor)
//  k-  i- ,   factor
{
  for(int j = 0; j < col; j++)
    (*a[j]).v[k]-= (*a[j]).v[i] * factor;
}

void Matrix::MakeMain(int i)// i-   
{
  SwapLines(i, (*a[i]).NumbMainElement(i));
}

Matrix Matrix::operator~()
{
  int i, imain, k;
  if(row != col)
    throw("The inversion of the rectangle matrix");
  Matrix E(row, row);
  Matrix Tmp(*this);
  for(i = 0; i < row; i++)
    (*E.a[i]).v[i] = 1.0;
  for(i = 0; i < row; i++){
    imain = (*a[i]).NumbMainElement(i);
    SwapLines(i, imain);
    E.SwapLines(i, imain);
    double divisor = (*a[i]).v[i];
    DivLine(i, divisor);
    E.DivLine(i, divisor);
    for(k = 0; k < row; k++){
      if(k == i) continue;
      double factor = (*a[i]).v[k];
      DiffLines(k, i, factor);
      E.DiffLines(k, i, factor);
    }
  }
  *this = Tmp;
  return E;
}

Vector Matrix::GetLine(int i)// i-  
{
  Vector ai(col);
  for(int j =0; j < col; j++)
    ai.v[j] = (*a[j]).v[i];
  return ai;
}

Vector SystemEq::SolveSystem(void)//  
{
  return ~*this * Vector(*this);  // 
//  return operator~().operator*(Vector(*this));
//  Vector(*this) ,  
//      
//Matrix::operator*(const Matrix&)  Matrix::operator*(const Vector&)
}
