#ifndef LNALGEBRH
#define LNALGEBRH
#ifdef __DLL__
#define DLL_EI __declspec(dllexport)
#else
#define DLL_EI __declspec(dllimport)
#endif

// Vector   

#include <iostream.h>
class Vector {
  double* v;            //  
  int size;             //  ;
public:
  friend class Matrix;  //   
  DLL_EI Vector(int r=1);      //
  DLL_EI Vector(const Vector&);// 
  DLL_EI ~Vector()             //
  {delete[] v;}

  double&  DLL_EI operator[](int i) //  
  {return v[i];}
  double&  DLL_EI ElemV(int i)      //  
  {return v[i - 1];}

//     
  friend ostream&  DLL_EI operator<<(ostream&, const Vector&);
  friend istream&  DLL_EI operator>>(istream&, Vector&);

//  /     
  friend ostream&  DLL_EI operator<<(ostream&, const Matrix&);
  friend istream&  DLL_EI operator>>(istream&,Matrix&);

  Vector&  DLL_EI operator=(const Vector&);     // 
  Vector  DLL_EI operator+(const Vector&);      // 
  Vector  DLL_EI operator-(const Vector&);      // 
  Vector&  DLL_EI operator*(const double);      //   
  Vector&  DLL_EI operator-();                  // 

  int DLL_EI operator==(const Vector&)const;   //   
  int DLL_EI operator!=(const Vector&)const;   //  

  double DLL_EI operator*(const Vector&)const; // 

  double DLL_EI norma()const;                  // 
  friend double DLL_EI V_cos(const Vector&,const Vector&); // 
                                                    // 
  int NumbMainElement(int i);//    
                //,       i
};
//------------------------------------------
class Matrix{
  int row, col ;    //    
public:
  DLL_EI Matrix(int n = 1,int m = 1);  //
  DLL_EI Matrix(const Matrix&);        // 
  DLL_EI ~Matrix();                    //
  Matrix& DLL_EI operator=(const Matrix&); // 

  double& DLL_EI ElemM(int i, int j)   //   
  {return (*a[j - 1]).v[i - 1];}
  Matrix DLL_EI operator~();           // 

  //   
  friend ostream& DLL_EI operator<<(ostream&, const Matrix&);
  //   
  friend istream& DLL_EI operator>>(istream&, Matrix&);
  Matrix DLL_EI operator+(const Matrix&);  // 
  Matrix DLL_EI operator-(const Matrix&);  // 
  Matrix& DLL_EI operator*(const double);  //   
  Matrix& DLL_EI operator-();              //  -  
  int DLL_EI operator==(const Matrix&);    //   
  int DLL_EI operator!=(const Matrix&);    //  
  Matrix DLL_EI operator*(const Matrix&);  //   
  Vector DLL_EI operator*(const Vector&);  //   
private:
//    - ,  
  Vector **a;
  void SwapLines(int i, int j); //  
  void MakeMain(int i);     // i-   
  void DivLine(int i, double divisor);// i-   divisor
//  k-  i- ,   factor
  void DiffLines(int k, int i, double factor);
  Vector GetLine(int i);// i-  
};
//-----------------------------------------------------------------------

//     
//    
DLL_EI class SystemEq: public Matrix, public Vector
{
public:
//     . 
   SystemEq(int n = 1): Matrix(n, n), Vector(n)
  {}
  Vector SolveSystem(void);//  
};

#endif
